# Расшифровка событий

Список параметров входящих событий, адаптированный для CRM.

## Общие параметры

* **call_id** — идентификатор вызова в Asterisk. У событий, относящихся к одному вызову, значение поля call_id будет одинаковым
* **event** — имя события. возможные значения:
  * входящий вызов:
    - **inbound_start** - при поступлении входящего вызова на АТС (можно использовать для перенаправления вызова на поератора)
    - **inbound_dial_start** - при поступлении вызова конкретному оператору
    - **inbound_dial_answer** - при ответе оператора
    - **inbound_dial_end** - при конце разговора оператора
    - **inbound_end** - завершение входящего звонка
  * исходящий вызов:
    - **outbound_start** - при начале исходящего вызова на АТС
    - **outbound_dial_start** - при дозвоне до абонента (у абонента звонит телефон)
    - **outbound_dial_answer** - в момент ответа абонента на вызов (если ответа нет, этого события не будет)
    - **outbound_dial_end** - когда вызов закончился (dial_status = ANSWER значит, что вызов был отвечен)
    - **outbound_end** - завершение исходящего вызова
* **call_direction** — изначальное направление вызова
  - inbound - входящий
  - outbound - исходящий
  - internal - внутренний
* **call_cid_num** — изначальный номер звонящего при поступлении вызова
* **call_callee_num** — изначально вызванный номер при поступлении вызова
* **did** - номером, на который поступил вызов ( тот, который набирал абонент )

### Не важны в плане интеграции с CRM.

* call_start_time — время начала вызова [ - ]
* event_type — общий тип события (никогда не зависит от направления вызова в отличие от имени события)
  - call_start - при поступлении входящего вызова на АТС
  - dial_start - начало вызова
  - dial_answer - абонент ответил
  - dial_end - завершение разговора
  - call_end - 
* direction — направление текущего этапа вызова [ - ]
  - inbound - входящий
  - outbound - исходящий
  - internal - внутренний
* cid_num — номер звонящего на текущем этапе вызова [ - ]
* callee_num — вызванный номер на текущем этапе вызова [ - ]