# О плагине

Плагин позволяет предоставлять статистику из CRM по основным показателям за выбранный пользователем период. Все сообщения отправляются приватно.

# Возможности

* Отправка статистики всем пользователям, подписанным на бота и имеющим достум к CRM
* Мгновенная отправка данных
* Поддержка различных мессенжеров:
  - Telegram
  - Viber
  - Slack (сбор заявок)
  - Vk.com (сбор заявок)
* Возможность выбора показателя и периода отчетности
* Отправка статистики в текстовом и графическом виде (Диаграмма)
* Ведение лога отправленных сообщений

#Бот для Telegram <i class="icon-paper-plane blue"></i>

1. **Зарегистрируйте бота**:
 - в Telegram ([https://tlgrm.ru/docs/bots](https://tlgrm.ru/docs/bots "Инфо по ботам в Telegram"))
2. **Подключим бота к плагину** на вкладке "Боты, Пользователи"
 - Достаточно указать тип бота и Secret Key
 - Далее нажмем "Проверить" - в случае успешного подключения будут заполнены поля "Bot ID" и "Имя бота"
 - После сохранения бота можно узнать состояние подключения Webhook с помощью ссылки "Инфо" в колонке "Действия"
3. **Добавляем сотрудников**, которому будет доступна возможность получать уведомления
 - Заполненное поле "User ID" дает плагину понять, что сотрудник подписан на уведомления
 - Поле "User ID" можно не заполнять, оно будет заполнено при первом подключении сотрудника к боту
 - Уведомления будут получать только активные пользователи CRM

### Подключение к боту

Для работы с подключенным ботом начните с ним диалог, далее выбирайте соответствующее действие, используя для удобства клавиатуру.

 
#Бот для Viber <i class="icon-whatsapp fiolet"></i>

1. **Зарегистрируемся в Админ-панели** - [https://partners.viber.com/login](https://partners.viber.com/login "Инфо"). После регистрации мы попадем в панель и сможем создавать ботов
2. **Добавим бота** с помощью кнопки **Create Bot Account**
  - добавим аватар бота
  - укажем необходимую информацию
  - принимаем соглашение
  - жмем кнопку "Create"
  В результате мы получим Token такого вида -  **4875a8xxxx-d949xxxxx-463xxx**
3. **Подключим бота к плагину** на вкладке "Боты, Пользователи"
 - Достаточно указать тип бота и Secret Key
 - Далее нажмем "Проверить" - в случае успешного подключения будут заполнены поля "Bot ID" и "Имя бота"
 - Сохраняем данные



### Подписка на уведомления и отписка

Для получения уведомлений каждый сотрудник должен самостоятельно пройти авторизацию Плагина - сопоставить пользователя Viber и пользователя SalesMan CRM. Для этого:

1. Предоставьте сотруднику ссылку на бота
2. Сотрудник подключается к боту и указывает либо Логин от CRM, либо Email, либо номер мобильного, указанного в личных настройках
3. Сотрудник подписан

> ### <h3 class="red">Важно</h3>
> - Предоставление статистики производится только активным сотрудникам, т.е. если пользователь деактивирован или удален из системы, то доступ к статистике он получать не будет.
> - Пользователя можно заблокировать в пределах плагина (без деактивации в CRM)

# Доступ к управлению плагином

По умолчанию доступ к настройкам плагина имеют ВСЕ администраторы. Для ограничения доступа конкретным сотрудникам необходимо провести настройки в разделе "Доступы".

> ### <h3 class="red">Важно</h3>
> Доступ к плагину предоставляет ВСЕ возможности по управлению его настройками без ограничения функционала

